unit Unit3;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VCLTee.Chart, VCLTee.TeEngine, VCLTee.TeCanvas, VCLTee.Series;

type
  TForm3 = class(TForm)
    imgChart: TImage;
    Panel1: TPanel;
    btnCreateChartImg: TButton;
    procedure btnCreateChartImgClick(Sender: TObject);
    procedure imgChartClick(Sender: TObject);
  private
    { Private declarations }
    function CreateIncomeChart(aRect: TRect): TBitmap;
    procedure UpdateChartImage;
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

const BG_FONT_NAME = 'Segoe UI';
  CHART_SCALE = 2;

procedure TForm3.btnCreateChartImgClick(Sender: TObject);
begin
  UpdateChartImage;
end;

procedure TForm3.UpdateChartImage;
var
  lBmp: TBitmap;
begin
  lBmp := CreateIncomeChart(Rect(0, 0, imgChart.Width * CHART_SCALE, imgChart.Height * CHART_SCALE));
  try
    imgChart.Picture.Bitmap := lbmp;
  finally
    lbmp.Free;
  end;
end;

function TForm3.CreateIncomeChart(aRect: TRect): TBitmap;
var
  lChart: TChart;

  function CreateChart: TChart;
  begin
    result := TChart.Create(self);

    result.MarginLeft := 0;
    result.MarginRight := 2;
    result.MarginBottom := 0;
    //result.Parent := FfrmParent; {$message warn 'ETD: *** still needed?'}
    result.Color := clWhite;
    result.BevelOuter := bvNone;
    result.LeftAxis.Grid.Visible := True; //FBGConfig.ChartOptions.ShowHorzLines;
    result.AxisBehind := True;

    result.BottomAxis.Title.Font.Name := BG_FONT_NAME;
    result.BottomAxis.Title.Font.Size := result.BottomAxis.Title.Font.Size * CHART_SCALE;

    result.Legend.Font.Name := BG_FONT_NAME;
    result.Legend.Font.Size := result.Legend.Font.Size * CHART_SCALE;

    result.LeftAxis.LabelsFont.Name := BG_FONT_NAME;
    result.LeftAxis.LabelsFont.Size := result.LeftAxis.LabelsFont.Size * CHART_SCALE;

    result.LeftAxis.Grid.Color := clSilver;
    result.LeftAxis.AutomaticMinimum := False;
    result.LeftAxis.Minimum := 0;
    result.LeftAxis.MinorTicks.Visible := False;
    result.LeftAxis.TicksInner.Visible := False;
    result.LeftAxis.Ticks.Style := psDot;
    result.LeftAxis.TickLength := 2;
    result.LeftAxis.Axis.Width := 1;

    result.LeftAxis.Title.Font.Name := BG_FONT_NAME;
    result.LeftAxis.Title.Font.Size := result.LeftAxis.Title.Font.Size * CHART_SCALE;

    result.BottomAxis.LabelsFont.Name := BG_FONT_NAME;
    result.BottomAxis.LabelsFont.Size := result.BottomAxis.LabelsFont.Size * CHART_SCALE;

    result.Legend.Title.Font.Name := BG_FONT_NAME;
    result.Legend.Title.Font.Style := [];
    result.Legend.Title.Font.Size := result.Legend.Title.Font.Size * CHART_SCALE;


    result.BottomAxis.Axis.Color := clSilver;
    result.BottomAxis.MinorTicks.Visible := false;
    result.BottomAxis.Ticks.Visible := false;
    result.BottomAxis.Grid.Visible := False;
    result.BottomAxis.Axis.Width := 1;

    result.Legend.Frame.Visible := False;

    result.Legend.LegendStyle := lsSeries;
    result.Legend.Shadow.Visible := false;
    //result.Legend.Shadow.HorizSize := 0;
    //result.Legend.Shadow.VertSize := 0;
    result.Legend.Alignment := laRight;
    result.Legend.Transparent := True;

    result.LeftAxis.Axis.Color := clSilver;
    result.LeftAxis.AxisValuesFormat := '$,0';

    result.Walls.Visible := False;

    result.BackWall.Pen.Color := clSilver;
//    result.OnGetAxisLabel := ChartAxisLabel;

    result.View3D := False;
  end;


  function CreateChartSeries(aTitle: string): TAreaSeries;
  begin
    result := TAreaSeries.Create(self);
    result.ParentChart := lChart;
    result.AreaLinesPen.Visible := false;
    result.Pen.Visible := false;
    if lChart.SeriesCount > 1 then
      lChart.SeriesList.Move(lChart.SeriesCount - 1, 0);
    result.Title := aTitle;
    result.MultiArea := maStacked;
  end;

var
  lsrs: TAreaSeries;
begin
  lChart := CreateChart;
  try
    lsrs := CreateChartSeries('Test');
    lsrs.FillSampleValues(20);

    lsrs := CreateChartSeries('Test 2');
    lsrs.FillSampleValues(20);

    lsrs := CreateChartSeries('Test 3');
    lsrs.FillSampleValues(20);

    result := lChart.TeeCreateBitmap(clWhite, aRect);
  finally
    lChart.Free;
  end;
end;

procedure TForm3.imgChartClick(Sender: TObject);
begin
  UpdateChartImage;
end;

end.
